???File Path
==========
***...\Models\corporate\CorporateModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@  CorporateCustomDataConf  @@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlCorporateCustomDataConf : MdlUserAction {

	public long binCorporateCustomDataConfId { get; set; } = 0;
	[Required()]
	[Display(Name = "Customer")]
	public long binCustomerId { get; set; } = 0;
	[Required()]
	[Display(Name = "Corporate Custom Data")]
	public long binCorporateCustomDataId { get; set; } = 0;
	
	public short sinMandatory { get; set; } = 0;
	public short sinOptional { get; set; } = 0;
	[StringLength(100)]
	public string strDefault { get; set; } = "";
	
	public short sinOrder { get; set; } = 1;
	
}

public class MdlReqCorporateCustomDataConf : MdlRequest {

	public MdlCorporateCustomDataConf mdlCorporateCustomDataConf { get; set; } = new MdlCorporateCustomDataConf();
}

public class MdlResCorporateCustomDataConf : MdlResponse {

	public MdlCorporateCustomDataConf mdlCorporateCustomDataConf { get; set; } = new MdlCorporateCustomDataConf();
}

public class MdlResCorporateCustomDataConfList : MdlResponse {

	public List<MdlCorporateCustomDataConf> lstMdlCorporateCustomDataConf { get; set; } = new List<MdlCorporateCustomDataConf>();
}

public class MdlResCorporateCustomDataConfInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlCustomerBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlCorporateCustomDataBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlCorporateCustomDataConf> lstMdlCorporateCustomDataConf { get; set; } = new List<MdlCorporateCustomDataConf>();
}

