???File Path
==========
***...\ClientApp\srcpp\src\corporate\corporate-custom-data-conf\corporate-custom-data-conf.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlCorporateCustomDataConf, MdlReqCorporateCustomDataConf, MdlResCorporateCustomDataConf, MdlResCorporateCustomDataConfInit, MdlResCorporateCustomDataConfList } from '../../../models/corporate/corporate.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class CorporateCustomDataConfComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlCorporateCustomDataConf: MdlCorporateCustomDataConf = new MdlCorporateCustomDataConf();
                public intActiveCorporateCustomDataConfIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlCustomerBaseIntId: MdlBaseIntId[] = [];
			lstMdlCorporateCustomDataBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** CorporateCustomDataConf List
                @ViewChild('#idDgCorporateCustomDataConfList') idDgCorporateCustomDataConfList!: DxDataGridComponent;
                public lstAllCorporateCustomDataConf: MdlCorporateCustomDataConf[] = [];
                public blnDgCorporateCustomDataConfShowFilterRow: boolean = false;
                public blnDgCorporateCustomDataConfHeaderFilter: boolean = false;
                public intActiveCorporateCustomDataConfListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'corporateCustomDataConf';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "CORPORATECUSTOMDATACONF_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("CorporateCustomDataConf");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetCorporateCustomDataConfInitializeData')
                    .then((mdlResCorporateCustomDataConfInit: MdlResCorporateCustomDataConfInit) => {
                        if (mdlResCorporateCustomDataConfInit.sinStatus == 1) {
                            this.lstMdlCorporateCustomDataConf = mdlResCorporateCustomDataConfInit.lstMdlCorporateCustomDataConf;

                            // ??? Remove not use items !!!
					this.lstMdlCustomerBaseIntId = mdlResCorporateCustomDataConfInit.lstMdlCustomerBaseIntId;
					this.lstMdlCorporateCustomDataBaseIntId = mdlResCorporateCustomDataConfInit.lstMdlCorporateCustomDataBaseIntId;

                        } else {
                            console.log(mdlResCorporateCustomDataConfInit.strMessage + " => " + mdlResCorporateCustomDataConfInit.strErrorCode + ' -> ' + mdlResCorporateCustomDataConfInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->CORPORATECUSTOMDATACONF.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnCorporateCustomDataConfListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnCorporateCustomDataConfListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlCorporateCustomDataConf);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqCorporateCustomDataConf: MdlReqCorporateCustomDataConf = new MdlReqCorporateCustomDataConf();
            mdlReqCorporateCustomDataConf.mdlCorporateCustomDataConf = JSON.parse(JSON.stringify(this.mdlCorporateCustomDataConf));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveCorporateCustomDataConf', mdlReqCorporateCustomDataConf)
                .then((mdlResCorporateCustomDataConf: MdlResCorporateCustomDataConf) => {
                if (mdlResCorporateCustomDataConf.sinStatus == 1) {
                    this.mdlCorporateCustomDataConf = mdlResCorporateCustomDataConf.mdlCorporateCustomDataConf;
                    if (this.intActiveCorporateCustomDataConfIndex == -1) {
                    // New Item
                    this.intActiveCorporateCustomDataConfIndex = this.lstMdlCorporateCustomDataConf.length;
                    this.lstMdlCorporateCustomDataConf.push(JSON.parse(JSON.stringify(this.mdlCorporateCustomDataConf)));
                    }
                    else {
                    // Update
                    this.lstMdlCorporateCustomDataConf[this.intActiveCorporateCustomDataConfIndex] = JSON.parse(JSON.stringify(this.mdlCorporateCustomDataConf));
                    //this.lstMdlCorporateCustomDataConf.splice(this.intActiveCorporateCustomDataConfIndex, 1, this.mdlCorporateCustomDataConf);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResCorporateCustomDataConf.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResCorporateCustomDataConf.strMessage, mdlResCorporateCustomDataConf.strSysError);
                    console.log(mdlResCorporateCustomDataConf);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->CORPORATECUSTOMDATACONF.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlCorporateCustomDataConf.binCorporateCustomDataConfId == null || this.mdlCorporateCustomDataConf.binCorporateCustomDataConfId < 1) {
                throw new Error('Select CorporateCustomDataConf for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqCorporateCustomDataConfBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqCorporateCustomDataConfBaseIntId.mdlBaseIntId.binPkId = this.mdlCorporateCustomDataConf.binCorporateCustomDataConfId;
            mdlReqCorporateCustomDataConfBaseIntId.mdlBaseIntId.binCustomValue = this.mdlCorporateCustomDataConf.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteCorporateCustomDataConf', mdlReqCorporateCustomDataConfBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlCorporateCustomDataConf.splice(this.intActiveCorporateCustomDataConfIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->CORPORATECUSTOMDATACONF.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlCorporateCustomDataConf = new MdlCorporateCustomDataConf();
                    this.intActiveCorporateCustomDataConfIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlCorporateCustomDataConf: MdlCorporateCustomDataConf, intRowIndex: number) {
                this.mdlCorporateCustomDataConf = JSON.parse(JSON.stringify(mdlCorporateCustomDataConf));
                this.intActiveCorporateCustomDataConfIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlCorporateCustomDataConf: MdlCorporateCustomDataConf) {
                // ??? CHECK
                
                if (mdlCorporateCustomDataConf.binCustomerId == 0) {
                    throw new Error('Enter/Select Customer.');
                }
            
                if (mdlCorporateCustomDataConf.binCorporateCustomDataId == 0) {
                    throw new Error('Enter/Select Corporate Custom Data.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

